/*
letra.c Wordle9511, ejemplo de juego sobrediseñado con TDAs.
Copyright (C) 2022 Sebastian Santisi <ssantisi@fi.uba.ar>
*/
#include "letra.h"

#include <stdlib.h>

// El TDA letra contiene el carácter c y el estado e. Formalmente no es un TDA
// dado que no hay comportamiento asociado. (Ver ACLARACIÓN en letra.h)
struct letra {
    char c;
    letra_estado_t e;
};

letra_t *letra_crear(char caracter) {
    letra_t *l = malloc(sizeof(letra_t));
    if(l == NULL)
        return NULL;

    l->c = caracter;
    l->e = LETRA_NO_ARRIESGADA;

    return l;
}

void letra_destruir(letra_t *l) {
    free(l);
}

char letra_get_caracter(const letra_t *l) {
    return l->c;
}

letra_estado_t letra_get_estado(const letra_t *l) {
    return l->e;
}

void letra_set_estado(letra_t *l, letra_estado_t estado) {
    l->e = estado;
}
