/*
letra.h Wordle9511, ejemplo de juego sobrediseñado con TDAs.
Copyright (C) 2022 Sebastian Santisi <ssantisi@fi.uba.ar>
*/
#ifndef LETRA_H
#define LETRA_H

// TDA que representa a una letra y su estado ante el juego
// ACLARACIÓN: Esto es un sobrediseño, tranquilamente esto podría ser una
// estructura pública y ser manejada con memoria estática. No hay justificativo
// para que esto esté implementado como un TDA encapsulado salvo el ejemplo.
typedef struct letra letra_t;

// Estados posibles de una letra
typedef enum {LETRA_NO_ARRIESGADA, LETRA_NO_ACERTADA, LETRA_POSICION_CORRECTA, LETRA_POSICION_INCORRECTA} letra_estado_t;

// Crea un TDA letra representando al caracter y con estado LETRA_NO_ARRIESGADA
letra_t *letra_crear(char caracter);

// Destruye la memoria asociada a l
void letra_destruir(letra_t *l);

// Getter del caracter de l
char letra_get_caracter(const letra_t *l);

// Getter del estado de l
letra_estado_t letra_get_estado(const letra_t *l);

// Setter del estado en l
void letra_set_estado(letra_t *l, letra_estado_t estado);

#endif
